; TOKI
; original boot block
; hardware custom trackloader
; SYNC : $4124 (standard $4489) pistes 112  159
; DSKLEN : $98C4
; BYTEPERTRACK : $18B8 (standard $1600)
; disk size=159*$18B8+$1600

	dc.b 'DOS',0
	dc.l 0
	dc.l 0

lmb	btst	#6,$bfe001
	bne.s	lmb
	bsr	TrackLoader
	move.w	#$f00,$dff180
lmb2	btst	#6,$bfe001	
	bne.s	lmb2
;	lea	TrackLoader(pc),a0
;	lea	$60000,a1	; copy main prog to exception vector $10
;	move.l	a1,$10.w	; if a Illegal instruction occurs, jump to vector $10
;	move.w	#(sizetrackloader/4)-1,d0
;_copy:	move.l	(a0)+,(a1)+
;	dbf	d0,_copy
;	illegal			; start	in Supervisor mode
;------------------------------------------------
TrackLoader:
	move.l	#$7FFF7FFF,d0	; stop operating system
	move.l	d0,$DFF09A	; all interruptions off
	move.w	d0,$DFF096	; all dma off
;	lea	$400.w,sp	; Supervisor Stack at 400
;	move.l	Datas(pc),-(sp)	; put Load buffer in stack to jump at the end.
;	move	#$2000,sr

	lea	Datas(pc),a0
	lea	DelaySoft(pc),a5
	lea	$BFD100,a4	; CIAB-PRB in A4
	lea	$DFF024,a6	; DSKLEN custom base in A6
	move.l	#$55555555,d6	; odd bits mask	MFM uncode
	move.l	(a0)+,d5	; Load address
	move.l	(a0)+,starttrk-vars(a5)	; start track*tracksize 157
	move.l	(a0)+,d4	; len track*tracksize 3
	move.l	#$18B8,d3	; custom track size 
				; (standard $1600. 696 bytes more = 110kb more on the disk)
	move.b	#$7F,(a4)	; Motor on
	jsr	(a5)		; cpu delay
	bclr	#3,(a4)		; DSKSEL0 select DF0
	jsr	(a5)		; cpu delay
	bsr	DiskReady

retry	clr.w	try-vars(a5)
; A4=BFD100 CIAB
; A6=DFF024 DSKLEN
; D3=Bytes per track
; D4=len
; D5=load address
; D7=start track
Load:
	move.l	starttrk-vars(a5),d7
	bsr	SeekTrack
	move.w	#$8210,$96-$24(a6)	; DMACON enable DMA Disk

.loopload:
	move.w	#$7F00,$9E-$24(a6)	; $9E erase ADKCON
	move.w	#$9500,$9E-$24(a6)	; good value in	ADKCON
	move.w	sync(pc),$7E-$24(a6)	; $7E DSKSYNC custom sync word	(standard $4489)
	move.w	#2,$9C-$24(a6)		; $9C INTREQ DSKBLK interrupt
	bsr	DiskReady		; CIAA-PRA - DSKRDY
	move.l	#$70000,$20-$24(a6)	; DSKPTH mfm buffer address
	move.w	#$4000,(a6)		; erase	DSKLEN
	move.w	#$98C4,(a6)		; DSKLEN raw read len (words) standard $9900 (-60 bytes)
	move.w	#$98C4,(a6)		; 2 times to start DMA transfert

	move.l	#$A0000,d7		; loop wait
.wait:
	btst	#1,$1F-$24(a6)		; wait for disk drive to be ready
	bne.s	.continue
	subq.l	#1,d7
	bne.s	.wait

	bra.s	.loopload

.continue:
	bsr.s	MFMUncodeCheck
	beq.s	.ok		; mfmbuffer
	addq.w	#1,try-vars(a5)	; nb try
	cmpi.w	#8,try-vars(a5)
	bls.s	Load
	moveq	#0,d7
	pea	retry-vars(a5)	; retry
	bra.w	SeekTrack
.ok:
	movea.l	buffer-vars(a5),a0	; mfmbuffer (70000)
	addq.w	#8,a0		; skip header sync
	movea.l	d5,a1		; load address (40000)
	move.w	rest-vars(a5),d0
	move.l	d3,d7	; track size
	sub.w	d0,d7	; - real size read
	lsr.w	#2,d7	; /2
	subq.w	#1,d7	; -1
	add.w	d0,d0	; rest*2 (words->bytes)
	adda.w	d0,a0	; skipped in mfmbuffer
.decode:
	move.l	(a0)+,d0	; even long word
	move.l	(a0)+,d1	; odd long word
	and.l	d6,d0		; mask clock bits
	and.l	d6,d1
	add.l	d1,d1		; rotate odd bits to left
	or.l	d1,d0		; merge odd and even bits
	move.l	d0,(a1)+	; store decoded long word

	subq.l	#4,d4		; len -4 bytes
	beq.s	StopDrive	; finished
	dbf	d7,.decode

	add.l	d3,starttrk-vars(a5)	; next track
	move.l	a1,d5		; load address for next track
	bra	Load
;--------------------------------------------------
StopDrive:
	bset	#7,(a4)		; DSKMOTOR off
	bset	#3,(a4)		; DSKSEL0 deselect df0
	jsr	(a5)		; delay
	bclr	#3,(a4)
	jsr	(a5)		; delay
	bset	#3,(a4)
	rts		; exit then start @ 40000 (load buffer)
;------------------------------------------------------
MFMUncodeCheck:
	movem.l	d1-a6,-(sp)
	movea.l	buffer-vars(a5),a0	; mfmbuffer = 70000
	bsr.s	MFMUncodeHeader
	move.l	d0,d1		; checksum
	swap	d1
	cmpi.w	#$5041,d1		; 'PA' = "Pierre Adane"
	bne.s	.error			; not a PA track
	cmp.w	track-vars(a5),d0	; check track number is
	bne.s	.error			; what we expected ? no
	subq.l	#8,a0			; yep. start of data
	move.w	#1583-1,d7	; decode 1583.L (18B8+4 bytes)
	moveq	#0,d3		; checksum
.decode:
	move.l	(a0)+,d0	; even long word
	move.l	(a0)+,d2	; odd long word
	and.l	d6,d0		; mask clock bits		
	and.l	d6,d2
	add.l	d0,d3		; rotate odd bits to the left
	add.l	d2,d3		; add to checksum
	dbf	d7,.decode

	bsr.s	MFMUncodeHeader
	cmp.l	d0,d3		; good checksum
	bne.s	.error		; no
	movem.l	(sp)+,d1-a6
	moveq	#0,d7		; ok
	rts	

.error	movem.l	(sp)+,d1-a6
	moveq	#-1,d7		; error
	rts	

MFMUncodeHeader:
	move.l	(a0)+,d0	; even MFM long word : $5249
	move.l	(a0)+,d1	; odd MFM long word
	and.l	d6,d0		; MFM mask
	and.l	d6,d1
	add.l	d1,d1		; rotate odd bits left
	or.l	d1,d0		; merge odd and even bits
	rts	
;-------------------------------------
DiskReady:
	btst	#5,$F01(a4)	; $BFE001 CIAA-PRA - bit DSKRDY
	bne.s	DiskReady
	rts	
;-------------------------------------
SeekTrack:
	movem.l	d0-d3,-(sp)
	move.l	d7,d0		; 157*18B8
	move.l	d3,d2		; track size 18b8
	divu	d2,d0		; F28D8/18B8 = 157 ($9d)
	move.w	d0,d1		; num track 157
	move.w	#$4488,sync-vars(a5)
	cmpi.w	#111,d1
	blt.s	.b1
	cmpi.w	#159,d1
	bgt.s	.b1
	btst	#0,d1
	beq.s	.b1
	move.w	#$4121,sync-vars(a5)
.b1	swap	d0
	move.w	d0,rest-vars(a5)	; 0
	ext.l	d0
	sub.l	d0,starttrk-vars(a5)	; f28d8-0
	cmpi.w	#80,d1		; >80 ?
	bge.s	_greater
	st	head-vars(a5)	; side 0
	bra.s	_less

_greater:
	sf	head-vars(a5)
	subi.w	#80,d1		; track on side 1

_less:
	move.b	d1,d7
	move.b	head-vars(a5),d0
	beq.s	Side1
	bset	#2,(a4)		; DSKSIDE side 0
	bra.s	seekthetrack
Side1:
	bclr	#2,(a4)		; DSKSIDE side 1

seekthetrack:
	jsr	(a5)		; cpu delay
	tst.b	track-vars(a5)	; track	>=0
	bge.s	seekForw
	bsr.s	Seek0

seekForw:
	cmp.b	track-vars(a5),d7	; current track	= seek track
	beq.s	seekOk
	blt.s	seekBack
	bsr.s	seekForward
	bra.s	seekIt

seekBack:
	bsr.s	seekBackward

seekIt:
	bsr.s	DiskReady	; CIAA-PRA - DSKRDY
	bra.s	seekForw
seekOk:	
	movem.l	(sp)+,d0-d3
	rts	

noTrack0:
	bsr.s	seekBackward

Seek0:
	btst	#4,$F01(a4)	; $BFE001 CIAA-PRA
	bne.s	noTrack0
	sf	track-vars(a5)	; clr
	rts	

seekForward:
	bclr	#1,(a4)		; DSKDIR goto 79
	addq.b	#1,track-vars(a5)	; incr current track
	bra.s	MoveHeads	; move +/-1 track

seekBackward:	
	bset	#1,(a4)		; DSKDIR goto 0
	subq.b	#1,track-vars(a5)	; decr current track

MoveHeads:	
	bclr	#0,(a4)		; DSKSTEP step low
	bset	#0,(a4)		; step high
;--------------------------------- Software Delay !!!
DelaySoft:	
vars
	move.w	d7,-(sp)
	move.w	#10000,d7	; ~7 ms
_wait:	dbf	d7,_wait
	move.w	(sp)+,d7
	rts	
;----------------------------------
buffer	dc.l $10000	; mfm track buffer
try	dc.w 0
rest	dc.w 0
starttrk dc.l 0		; 157*18B8
track	dc.b -1	; track	counter
head	dc.b 0		; side

Datas:	dc.l $20000	; dest buffer
	dc.l 157*$18B8	; start track (ad080)
	dc.l 3*$18B8	; len (489c8)
;sizetrackloader=*-Trackloader
sync	dc.w	$4488
	dc.b '-- TOKI bootloader! --Disk routine and protection written '
	dc.b 'by Pierre ADANE. ',0


		END
